<template>
  <div class="q-pa-md">
    <q-table
      title="Store"
      :rows="data"
      row-key="id"
      :columns="columns"
      :selected-rows-label="getSelectedString"
      selection="multiple"
      v-model:selected="selected"
      :key="id"
    >
      <template v-slot:body-cell-action="data">
        <q-td :data="data" align="right">
        
          <q-btn
           v-if="$isPerCrud($route.path, 'update', JSON.stringify(this.$store.state.example.userPermission))"
            color="primary"
            icon="edit"
            @click="openStoreModal(data.row)"
            size="sm"
            danse
            class="q-ml-sm"
          />
          <q-btn
            color="red"
            icon="delete"
            @click="openDeleteModal(data.row)"
            size="sm"
            danse
            class="q-ml-sm"
          />
        </q-td>
      </template>
      <template v-slot:top>
        <q-btn
          color="primary"
          :disable="loading"
          label="Add store"
          @click="openStoreModal(false)"
        />
        <q-btn
          v-if="selected.length"
          class="q-ml-sm"
          color="negative"
          label="Delete store"
          @click="openRemoveModal"
        />
        <q-space />
        <q-input
          dense
          rounded
          standout="bg-info text-white"
          v-model="text"
          input-class="text-right"
          class="q-ml-md"
        >
          <template v-slot:append>
            <q-icon v-if="text === ''" name="search" />
            <q-icon
              v-else
              name="clear"
              class="cursor-pointer"
              @click="text = ''"
            />
          </template>
        </q-input>
      </template>
    </q-table>

    <!-- Start Edit and create Modal  -->
    <q-dialog v-model="addStoreModal" persistent>
      <q-card
        style="min-width: 350px;"
        @keyup.enter="SendAddData"
        @keyup.esc="closeModal"
      >
        <q-card-section>
          <div class="text-h6">New Store</div>
        </q-card-section>
        <q-form id="validates">
          <q-card-section class="q-pt-none">
            <div class="text-h7">Name</div>
            <q-input dense v-model="newData.name" autofocus />
            <div class="text-h7 q-mt-md">Adress</div>
            <q-input dense v-model="newData.adress" />
            <div class="text-h7 q-mt-md  q-mb-md">Select user</div>
           <q-select
            filled
            v-model="newData.user_id"
            use-input
            use-chips
            multiple
            map-options
            emit-value
            option-value="id"
            option-label="name"
            input-debounce="0"
            @new-value="createValue"
            :options="userOption"
            style="width:350px;"
          />
          </q-card-section>
        </q-form>
        <q-card-actions align="right" class="text-primary">
          <q-btn
            flat
            label="Create"
            @click="createAddData"
            v-show="!newData.id"
          />
          <q-btn flat label="Save" @click="saveEditData" v-show="newData.id" />
          <q-btn flat label="Cancel" @click="closeModal" />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End Edit and create Modal  -->

    <!-- Start One Delete Modal  -->
    <q-dialog v-model="deleteModal" persistent>
      <q-card
        style="min-width: 350px;"
        @keyup.enter="deData.id"
        @keyup.esc="deleteModal = false"
      >
        <q-card-section class="bg-deep-orange text-white">
          <div class="text-h6">Are you sure delete this store ?</div>
        </q-card-section>
        <q-form id="validates">
          <q-card-section class="q-pt-md">
            <div class="text-h7 row">
              <p class="text-weight-bold q-pr-lg">Name :</p>
              {{ deData.name }}
            </div>
            <div class="text-h7 row">
              <p class="text-weight-bold q-pr-lg">Adress :</p>
              {{ deData.adress }}
            </div>
          </q-card-section>
        </q-form>
        <q-card-actions align="right" class="text-primary">
          <q-btn
            flat
            color="red"
            label="Delete"
            @click="deleteStore"
            v-show="!newData.id"
          />
          <q-btn flat label="Cancel" @click="deleteModal = false" />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End One Delete Modal  -->

    <!-- Start Multi Delete Modal  -->
    <q-dialog v-model="multiDeleteModal" persistent>
      <q-card
        style="min-width: 350px;"
        @keyup.enter="selected.id"
        @keyup.esc="multiDeleteModal = false"
      >
        <q-card-section class="bg-deep-orange text-white">
          <div class="text-h6">Are you sure delete this stores ?</div>
        </q-card-section>
        <q-form id="validates">
          <q-card-section class="q-pt-md">
            <div v-for="(selects, i) in selected" :key="i">
              <div class="row">
                <div class="row">
                  <p class="text-weight-bold q-pr-sm">{{ i + 1 }}. Name :</p>
                  {{ selects.name }}
                </div>
                <div class="row q-pl-md">
                  <p class="text-weight-bold q-pr-sm">Adress :</p>
                  {{ selects.adress }}
                </div>
              </div>
            </div>
          </q-card-section>
        </q-form>
        <q-card-actions align="right" class="text-primary">
          <q-btn
            flat
            color="red"
            label="Delete"
            @click="multiDeleteStore"
            v-show="!newData.id"
          />
          <q-btn flat label="Cancel" @click="multiDeleteModal = false" />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End Multi Delete Modal  -->
  </div>
</template>

<script>
import axios from 'axios'
import { date } from 'quasar'

export default {
  name: 'PageIndex',
  data() {
    return {
      text: '',
      data: [],
      selected: [],
      deData: {},
      deleteModal: false,
      addStoreModal: false,
      userOption:[],
      cur_user:{},
      multiDeleteModal: false,
      columns: [
        {
          name: 'index',
          field: 'name',
          label: 'Name',
          align: 'left',
          sortable: true,
        },
        {
          name: 'id',
          field: 'adress',
          label: 'Adress',
          align: 'left',
          sortable: true,
        },
        {
          name: 'create',
          field: 'created_at',
          label: 'Created at',
          format: (val) => date.formatDate(val, 'DD.MM.YYYY h:m'),
          align: 'left',
          sortable: true,
        },
        {
          name: 'update',
          field: 'updated_at',
          label: 'Updated at',
          align: 'left',
          format: (val) => date.formatDate(val, 'DD.MM.YYYY h:m'),
          sortable: true,
        },
        {
          name: 'action',
          label: 'Action',
          align: 'center',
          style: 'width: 20px !important',
        },
      ],
      newData: {
        name: '',
        adress: '',
        id: 0,
        user_id:[]
      },
    }
  },
  async mounted() {
    await this.getStore()
  },

  methods: {
    auth() {
      this.$e('You are not authorized')
      this.$q.loading.hide()
      this.$router
        .push('/login')
        .then((s) => {})
        .catch((e) => {})
    },
    openRemoveModal() {
      this.multiDeleteModal = true
    },
    multiDeleteStore() {
      let sender = JSON.stringify(this.selected)
      this.$axios
        .post('http://127.0.0.1:8000/api/store/deletes_stores', {
          data: sender,
        })
        .then((res) => {
          if (res.status === 200) {
            this.$s('Stores is deleted successfully')
            location.reload()
          }
        })
        .catch((e) => {
          if (e.response.status == 401) {
            this.auth()
          } else this.$e('somethin went wrong !')
        })
    },
   openStoreModal(row) {
      if (row) {
        console.log(row)
        this.newData.name = row.name
        this.newData.adress = row.adress
        this.newData.id = row.id
        row.user.forEach((element,index) => {
        this.newData.user_id[index] = element.id;
       }); 
        this.addStoreModal = true
      } else {
        this.addStoreModal = true
      }
    },
    openDeleteModal(delData) {
      this.deData = delData
      this.deleteModal = true
    },
    deleteStore() {
      this.$q.loading.show()
      this.$axios
        .delete(
          'http://127.0.0.1:8000/api/store/delete_store/' + this.deData.id,
        )
        .then((res) => {
          if (res.status === 200) {
            if (res.data === 1) {
              this.$s('Store is deleted successfully')
              let i = 0
              let cop = []
              this.data.forEach((element, index) => {
                if (element.id != this.deData.id) {
                  cop[i] = this.data[index]
                  i++
                }
              })
              this.data = cop
              this.$q.loading.hide()
              this.deleteModal = false
            } else {
              this.$w('this data not found !')
            }
            this.deleteModal = false
          }
        })
        .catch((e) => {
          if (e.response.status == 401) {
            this.auth()
          } else {
            this.$q.loading.hide()
            this.$w('something went wrong !')
          }
        })
    },
    removeStore() {
      console.log(this.selected)
    },
    getStore() {
      this.$q.loading.show()
      this.$axios
        .get('http://127.0.0.1:8000/api/store/get_store')
        .then((response) => {
          if (response.status == 200) {
            this.data = response.data.store[0].store;
            this.userOption= this.data.user;
            this.$q.loading.hide()
            console.log(this.data);
            // console.log(response.data.store)
          }
        })
        .catch((e) => {
          if (e.response.status == 401) {
            this.auth()
          } else {
            this.$e('something went wrong !')
            this.$q.loading.hide()
          }
        })
     this.$axios.get('http://127.0.0.1:8000/api/store/getUsers').then((res)=>{
          if(res.status == 200){
          this.userOption=res.data.users;
          this.newData.user_id[0] = res.data.auth.id
          this.cur_user = res.data.auth
          }else{
            this.$e("Something Went wrong !");
          }
        })
    },
    closeModal() {
      this.addStoreModal = false
      this.newData.name = ''
      this.newData.adress = ''
      this.newData.id = 0,
      this.newData.user_id = []
      this.newData.user_id[0] = this.cur_user.id;
    },

    createAddData() {
      console.log(this.newData);
      if (this.newData.name == undefined) {
        this.$e('name field is required !')
        return 0
      }
      if (this.newData.adress == undefined)
        this.$e('adress field is required !')
      else {
        this.$q.loading.show()
        this.$axios
          .post('http://127.0.0.1:8000/api/store/create_store', this.newData)
          .then((res) => {
            if (res.status === 201) {
              this.$q.loading.hide()
              this.$s('new store save successfully !')
              this.addStoreModal = false
              // location.reload();
            }
          })
          .catch((e) => {
            if (e.response.status == 401) {
              this.auth()
            } else if (e.response.status === 422) {
              var error = e.response.data.errors.name
                ? e.response.data.errors.name
                : e.response.data.errors.adress
              this.$q.loading.hide()
              this.$e(error)
            }
          })
      }
    },
    saveEditData() {
      if (this.newData.name.trim() == '') {
        this.$e('name field is required !')
        return 0
      }  
      if (this.newData.user_id == '') {
        this.$e('Select user field is required !')
        return 0
      }
      if (this.newData.adress.trim() == '')
        this.$e('adress field is required !')
      else {
        this.$q.loading.show()
        this.$axios
          .put('http://127.0.0.1:8000/api/store/update_store', this.newData)
          .then((res) => {
            console.log(res.data)
            if (res.status == 200) {
              this.data.find((element, index) => {
                if (element.id == this.newData.id) {
                  this.data[index].name = this.newData.name
                  this.data[index].id = this.newData.id
                  this.data[index].adress = this.newData.adress
                  this.data[index].user_id = this.newData.user_id
                }
              })
              this.newData.id = 0
              this.$s('store edit successfully !')
              this.$q.loading.hide()
              location.reload();
            }
          })
          .catch((e) => {
            if (e.response.status == 401) {
              this.auth()
            } else if (e.response.status === 422) {
              var error = e.response.data.errors.name
                ? e.response.data.errors.name
                : e.response.data.errors.adress
              this.$e(error)
              this.$q.loading.hide()
            }
          })
      }
    },
  },
}
</script>
